# WorkAllocationConfigurationType (Complex Type)

### Namespace: http://midpoint.evolveum.com/xml/ns/public/common/common-3

Parameters related to buckets allocation process.

Item Summary
Name | Type | Multiplicity | Description
--- | --- | --- | ---
bucketCreationBatch | property int | [0,1] | How many buckets are to be created at once (when needed)? EXPERIMENTAL
allocateFirst | property boolean | [0,1] | Should the first available bucket be always allocated? EXPERIMENTAL
workAllocationMaxRetries | property int | [0,1] | How many retries for allocation of a work bucket should be attempted? The default is specified in the system configuration.
workAllocationRetryIntervalBase | property long | [0,1] | The base for exponential growth of the retry interval window.
workAllocationRetryExponentialThreshold | property int | [0,1] | The retry number from which the retry delay window starts to be constant (instead of exponentially dependent on retry number).
workAllocationRetryIntervalLimit | property long | [0,1] | Alternative way of limiting the retry delay growth.
workAllocationInitialDelay | property long | [0,1] | Size of random interval for the initial delay.
workAllocationFreeBucketWaitInterval | property long | [0,1] | If specified, overrides the time used to wait for free bucket(s) reclamation.

- ### Items

  - #### bucketCreationBatch

    Flags: RAM,runtime

    Multiplicity: [0,1]

    How many buckets are to be created at once (when needed)? EXPERIMENTAL

  - #### allocateFirst

    Flags: RAM,runtime

    Multiplicity: [0,1]

    Should the first available bucket be always allocated? EXPERIMENTAL

  - #### workAllocationMaxRetries

    Flags: RAM,runtime

    Multiplicity: [0,1]

    How many retries for allocation of a work bucket should be attempted? The default is specified in the system configuration.

  - #### workAllocationRetryIntervalBase

    Flags: RAM,runtime

    Multiplicity: [0,1]

    The base for exponential growth of the retry interval window. The actual delay is computed as random() * retryIntervalBase * 2 ^ (min(retryNumber, exponentialThreshold) - 1) Where retryNumber goes from 1 upwards. The default is specified in the system configuration.

  - #### workAllocationRetryExponentialThreshold

    Flags: RAM,runtime

    Multiplicity: [0,1]

    The retry number from which the retry delay window starts to be constant (instead of exponentially dependent on retry number). The default is specified in the system configuration.

  - #### workAllocationRetryIntervalLimit

    Flags: RAM,runtime

    Multiplicity: [0,1]

    Alternative way of limiting the retry delay growth. If specified, this is an absolute limit on the delay window size (i.e. the factor that multiplies the random number of 0..1).

  - #### workAllocationInitialDelay

    Flags: RAM,runtime

    Multiplicity: [0,1]

    Size of random interval for the initial delay. The default is specified in the system configuration.

  - #### workAllocationFreeBucketWaitInterval

    Flags: RAM,runtime

    Multiplicity: [0,1]

    If specified, overrides the time used to wait for free bucket(s) reclamation. This is applied when no free buckets are available but the work is not completely done.